#ifndef LIERO_CONTROLLER_LOCAL_CONTROLLER_HPP
#define LIERO_CONTROLLER_LOCAL_CONTROLLER_HPP

#include "commonController.hpp"

#include "../game.hpp"

#include "../worm.hpp"
#include "../weapsel.hpp"
#include "../replay.hpp"
#include "../console.hpp"
#include <gvl/serialization/except.hpp>
#include <ctime>

struct WeaponSelection;
struct ReplayWriter;

struct LocalController : CommonController
{
	LocalController(gvl::shared_ptr<Common> common, gvl::shared_ptr<Settings> settings);
	~LocalController();
	void onKey(int key, bool keyState);
	
	// Called when the controller loses focus. When not focused, it will not receive key events among other things.
	void unfocus();
	// Called when the controller gets focus.
	void focus();
	bool process();
	void draw(Renderer& renderer, bool useSpectatorViewports);
	void changeState(GameState newState);
	void endRecord();
	void swapLevel(Level& newLevel);
	Level* currentLevel();
	Game* currentGame();
	bool running();
	
	Game game;
	std::unique_ptr<WeaponSelection> ws;
	GameState state;
	int fadeValue;
	bool goingToMenu;
	#ifndef NO_REPLAY
	std::unique_ptr<ReplayWriter> replay;
	#endif
};

#endif // LIERO_CONTROLLER_LOCAL_CONTROLLER_HPP
